#include<stdio.h>
#include<stdlib.h>
#include<mpi.h>

#define donja(id,b,n) ((id*n)/b)
#define gornja(id,b,n) (donja(id+1)-1)
#define koliko(id,b,n) (gornja(id,b,n)-donja(id,b,n)+1)
#define k 100
typedef struct statistika{
	int oruzje;
	int br_pobeda;
	int br_poraza;
}Stat;

typedef struct igrac{
	int trenutnoOruzje;
	int x;
	int y;
	int br_pobeda;
	int br_poraza;
}Igrac;

typedef struct maksimum{
	int x;
	int y;
	int br_pobeda;
}Maks;

int takmicenje(int prviO, int drugiO){
	if((prviO==0 && drugiO==1)
	|| (prviO==2 && drugiO==0)
	|| prviO==1 && drugiO==2){
		return 1;
	}
	else if((prviO==1 && drugiO==0)
	|| (prviO==0 && drugiO==2)
	|| (prviO==2 && drugiO==1))
	{
		return 2;
	}
}

void SumStat(Stat *s1, Stat *s2, int *len, MPI_Datatype *tip){
	int i;
	for (i = 0; i < *len; i++)
	{
		if(s1->oruzje==s2->oruzje){
			s2->br_pobeda+=s1->br_pobeda;
			s2->br_poraza+=s1->br_poraza;
			*s1++;
			*s2++;
		}
	}
}

void funkcijaMaks(Maks *m1, Maks *m2, int *len, MPI_Datatype *tip){
	int i;
	for (i = 0; i < *len; i++)
	{
		if(m1->br_pobeda<m2->br_pobeda){
			*m2=*m1;
			*m1++;
			*m2++;
		}
	}
}

int main(int argc,char *argv[]){
	int brojProcesa, id, i,j;
	MPI_Status status;
	MPI_Datatype struktura,strukturaZaStat,kolona,strukturaZaMaks;
	MPI_Aint ext;
	MPI_Type_extent(MPI_INT,&ext);
	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&brojProcesa);
	MPI_Comm_rank(MPI_COMM_WORLD,&id);	
	
	
	int duzina=1;
	int offset[2];
	offset[0]=0;
	int blok[2];
	blok[0]=5;
	
	MPI_Type_struct(duzina,blok,offset,ext,&struktura);
	MPI_Type_commit(&struktura);
	
	
	
	duzina=1;
	offset[0]=0;
	blok[0]=3;
	MPI_Type_struct(duzina,blok,offset,ext,&strukturaZaStat);
	MPI_Type_commit(&strukturaZaStat);
	MPI_Type_struct(duzina,blok,offset,ext,&strukturaZaMaks);
	MPI_Type_commit(&strukturaZaMaks);
	
	int m=1000;
	int n=1000;
	
	int brojKolona=koliko(id,brojProcesa,n);
	int kolone=brojKolona+2;
	
	struktura *igraci=(struktura *)malloc(m*kolone*sizeof(struktura));
	strukturaZaStat *statistikaM=(strukturaZaStat *)malloc(3*sizeof(strukturaZaStat));
	
	MPI_Datatype_vector(m,1,kolone,struktura,&kolona);
	
	for (i = 0; i < m; i++)
	{
		for (j = 1; j < kolone-1; j++)
		{
			igraci[i*kolone+j].trenutnoOruzje=rand()%3;
			igraci[i*kolone+j].x=i;
			igraci[i*kolone+j].y=j;
			igraci[i*kolone+j].br_pobeda=0;
			igraci[i*kolone+j].br_poraza=0;
		}
	}
	
	for (i = 0; i < m; i++)
	{
		igraci[i*kolone].trenutnoOruzje=-1;
		igraci[i*kolone].x=i;
		igraci[i*kolone].y=0;
		igraci[i*kolone].br_pobeda=0;
		igraci[i*kolone].br_poraza=0;
		igraci[i*kolone+kolone-1].trenutnoOruzje=-1;
		igraci[i*kolone+kolone-1].x=i;
		igraci[i*kolone+kolone-1].y=kolone-1;
		igraci[i*kolone+kolone-1].br_pobeda=0;
		igraci[i*kolone+kolone-1].br_poraza=0;
	}
	int temp=1;
	strukturaZaMaks mojMaks;
	mojMaks.x=-1;
	mojMaks.y=-1;
	mojMaks.br_pobeda=0;
	while(temp<k){
		if(id!=brojProcesa-1){
			MPI_Send(&igraci[kolone-2],1,kolona,id+1,10,MPI_COMM_WORLD);
		}
		if(id!=0){
			MPI_Recv(&igraci[id*kolone],1,kolona,id-1,10,MPI_COMM_WORLD,&status);
			MPI_Send(&igraci[id*kolone+1],1,kolona,id-1,20,MPI_COMM_WORLD);
		}
		if(id!=brojProcesa-1){
			MPI_Recv(&igraci[id*kolone+kolone-1],1,kolona,id+1,20,MPI_COMM_WORLD,&status);
		}
		
		for (i = 0; i < m; i++)
		{
			for (j = 1; j < kolone-1; j++)
			{
				if(id!=0 && id!=brojProcesa-1){
					if(i<m-1 && i>0){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j-1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
					else if(i==m-1){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
					else if(i==0){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
					}
				}
				else if(id==0){
					if(i<m-1 && i>0 && j>1){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j-1].br_pobeda++;
						}
					}
					else if(i<m-1 && i>0 && j==1){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
					}
					else if(i==0 && j==1){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
					}
					else if(i==m-1 && j==1){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
				}
				else if(id==brojProcesa-1){
					if(i<m-1 && i>0 && j<kolone-2){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j-1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
					else if(i==m-1 && j<kolone-2){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
					else if(i==0 && j<kolone-2){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j+1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j-1].br_pobeda++;
						}
					}
					else if(i==0 && j==kolone-2){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i+1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[(i+1)*kolone+j-1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[(i+1)*kolone+j-1].br_pobeda++;
						}
					}
					else if(i==m-1 && j==kolone-2){
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[i*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
						if(takmicenje(igraci[i*kolone+j].oruzje,igraci[(i-1)*kolone+j-1].oruzje)==1){
							igraci[i*kolone+j].br_pobeda++;
							//igraci[i*kolone+j+1].br_poraza++;
						}
						else{
							igraci[i*kolone+j].br_poraza++;
							//igraci[i*kolone+j+1].br_pobeda++;
						}
					}
				}
			}
		}
		
		for (i = 0; i < m; i++)
		{
			for (j = 1; j < kolone-1; j++)
			{
				if(igraci[i*kolone+j].trenutnoOruzje==0){
					statistikaM[0]+=igraci[i*kolone+j].br_pobeda;
				}
				else if(igraci[i*kolone+j].trenutnoOruzje==1){
					statistikaM[1]+=igraci[i*kolone+j].br_pobeda;
				}
				else if(igraci[i*kolone+j].trenutnoOruzje==2){
					statistikaM[2]+=igraci[i*kolone+j].br_pobeda;
				}
			}
		}
		for (i = 0; i < 3; i++)
		{
			printf("Statistika[%d]=%d\n",i,statistikaM[i]);
		}
		
		MPI_Op brojPobeda;
		MPI_Op_create((MPI_User_function *)SumStat,1,&brojPobeda);
		
		for (i = 0; i < 3; i++)
		{
			MPI_Reduce(&statistikaM[i],&statistikaM[i],1,struktura,brojPobeda,0,MPI_COMM_WORLD);
		}
		
		if(id==0){
			printf("Statistika[%d]=%d\n",i,statistikaM[i]);
		}
		
		temp++;
	}
	
	for (i = 0; i < m; i++)
	{
		for (i = 1; j < kolone-1; j++)
		{
			if(igraci[i*kolone+j].br_pobeda>mojMaks.br_pobeda){
				mojMaks.x=i;
				mojMaks.y=j;
				mojMaks.br_pobeda=igraci[i*kolone+j].br_pobeda;
			}
		}
	}
	
	MPI_Op najbolji;
	MPI_Op_create((MPI_User_function *)funkcijaMaks,1,&najbolji);
	
	MPI_Reduce(&mojMaks,&mojMaks,1,strukturaZaMaks,najbolji,0,MPI_COMM_WORLD);
	
	if(id==0){
		printf("Najbolji je igrac na polju sa koordinatama %d %d sa brojem pobeda %d\n",mojMaks.x,mojMaks.y,mojMaks.br_pobeda);
	}
	
	MPI_Finalize();
}
