#include<stdio.h>
#include<stdlib.h>
#include<mpi.h>

#define n 20

double povrsina(double x1, double x2, double x3, double x4, double y1, double y2, double y3, double y4){
	double P;
	//NAPOMENA
	//dodato abs jer povrsina moze da bude negativna vrednost!!!
	P = abs(( y1*(x4-x2) + y2*(x1-x3) + y3*(x2-x4) + y4*(x3-x1) ) / 2);
	//printf("%lf\n",P);
	return P;
}

void main(int argc, char *argv[]){
	int id,np,cnt=0,sfk,i,j;
	double *moje_povrsine,pov,max, final_max,max_koord[8],final_koord[8];
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &id);
	MPI_Comm_size(MPI_COMM_WORLD, &np);
	MPI_Status status;
	
	double xk[20] = {1.0,2,3,4,5,6,7,8,9,10,11,16,17,18,19,20,12,13,14,15};
	double yk[20] = {1.0,2,3,12,13,14,15,16,17,18,19,20,4,5,6,7,8,9,10,11};
	
	sfk = id; //start_first_koord
	//slk = 3+id; //start_last_koord
	
	max = 0.0;
	for(i=sfk; i<n; i+=np){
		for(j=i+3; j<n; j++){
			if(j < n){
				pov = povrsina(xk[i], xk[i+1], xk[i+2], xk[j], yk[i], yk[i+1], yk[i+2], yk[j]);
				if(pov >= max){
					max = pov;
					max_koord[0] = xk[i];
					max_koord[1] = xk[i+1];
					max_koord[2] = xk[i+2];
					max_koord[3] = xk[j];
					max_koord[4] = yk[i];
					max_koord[5] = yk[i+1];
					max_koord[6] = yk[i+2];
					max_koord[7] = yk[j];
				}
			}
		}
		
	}
	//printf("id %d, moj_max %lf\n",id,max);
	if(id != 0){
		MPI_Send(&max, 1, MPI_DOUBLE, 0, 10, MPI_COMM_WORLD);
		MPI_Send(&max_koord[0], 8, MPI_DOUBLE, 0, 10, MPI_COMM_WORLD);
	}
	else{
		final_max = max;
		for(i=1; i<np; i++){
			MPI_Recv(&max, 1, MPI_DOUBLE, i, 10, MPI_COMM_WORLD, &status);
			MPI_Recv(&final_koord, 8, MPI_DOUBLE, i, 10, MPI_COMM_WORLD, &status);
			if(final_max < max){
				//kopiraj koordinate
				for(j=0; j<8; j++){
					max_koord[j] = final_koord[j];
				}
				final_max = max;
			}
		}
		printf("koordinate najveceg cetvorougla: x1=%lf, x2=%lf, x3=%lf, x4=%lf, y1=%lf, y2=%lf, y3=%lf, y4=%lf\n", max_koord[0], max_koord[1], max_koord[2], max_koord[3], max_koord[4], max_koord[5], max_koord[6], max_koord[7]);
	}
	
	MPI_Finalize();
}
